package org.jeecg.modules.stm.audit.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
 
 
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.jeecg.modules.stm.audit.entity.AuditRiskEvent;
import org.jeecg.modules.stm.audit.service.IAuditLabelRelLibService;
import org.jeecg.modules.stm.audit.service.IAuditRiskEventService;
import org.jeecg.modules.stm.utils.StmConstans;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import java.util.Arrays;
import java.util.List;

/**
 * @Description: 风险事件
 * @Author: jeecg-boot
 * @Date:   2024-08-26
 * @Version: V1.0
 */

@RestController
@RequestMapping("/audit/auditRiskEvent")
@Slf4j
public class AuditRiskEventController extends JeecgController<AuditRiskEvent, IAuditRiskEventService> {
	@Autowired
	private IAuditRiskEventService auditRiskEventService;
	 @Autowired
	 private IAuditLabelRelLibService stLabelRelLibService;
	/**
	 * 分页列表查询
	 *
	 * @param auditRiskEvent
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "风险事件-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<AuditRiskEvent>> queryPageList(AuditRiskEvent auditRiskEvent,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<AuditRiskEvent> queryWrapper = QueryGenerator.initQueryWrapper(auditRiskEvent, req.getParameterMap());
		Page<AuditRiskEvent> page = new Page<AuditRiskEvent>(pageNo, pageSize);
		IPage<AuditRiskEvent> pageList = auditRiskEventService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param auditRiskEvent
	 * @return
	 */
	@AutoLog(value = "风险事件-添加")

	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody AuditRiskEvent auditRiskEvent) {
		auditRiskEventService.save(auditRiskEvent);
		String labelCodes = auditRiskEvent.getLabels();
		if(labelCodes!=null&&!labelCodes.equals("")) {
			Integer tid =  auditRiskEvent.getId();
			stLabelRelLibService.saveLabelRel(labelCodes,tid, StmConstans.Audit_TP_RISK_EVENT);
		}
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param auditRiskEvent
	 * @return
	 */
	@AutoLog(value = "风险事件-编辑")

	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody AuditRiskEvent auditRiskEvent) {
		auditRiskEventService.updateById(auditRiskEvent);
		String labels= auditRiskEvent.getLabels();
		if(labels!=null) {
			Integer tid =  auditRiskEvent.getId();
			stLabelRelLibService.deleteLabelRel(tid, StmConstans.Audit_TP_RISK_EVENT);
			if(!labels.equals("")) {
				stLabelRelLibService.saveLabelRel(labels,tid, StmConstans.Audit_TP_RISK_EVENT);
			}
		}
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "风险事件-通过id删除")

	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		auditRiskEventService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "风险事件-批量删除")

	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.auditRiskEventService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "风险事件-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<AuditRiskEvent> queryById(@RequestParam(name="id",required=true) String id) {
		AuditRiskEvent auditRiskEvent = auditRiskEventService.getById(id);
		if(auditRiskEvent==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(auditRiskEvent);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param auditRiskEvent
    */
    @RequiresPermissions("audit:audit_risk_event:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, AuditRiskEvent auditRiskEvent) {
        return super.exportXls(request, auditRiskEvent, AuditRiskEvent.class, "风险事件");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("audit:audit_risk_event:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, AuditRiskEvent.class);
    }


	@PostMapping(value = "/batchAdd")
	public void batchAdd(@RequestBody List<AuditRiskEvent> auditRiskEventList) {
		auditRiskEventService.saveBatch(auditRiskEventList);
	}


}
